package com.example.ivona.pametnosvjetlo;

import android.media.MediaPlayer;
import android.os.Bundle;
import android.support.design.widget.FloatingActionButton;
import android.support.design.widget.Snackbar;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.widget.Toolbar;
import android.view.View;
import android.view.Menu;
import android.view.MenuItem;
import android.widget.Button;

import java.io.IOException;

public class MainActivity extends AppCompatActivity {
//preuzela sve metode iz AppCompatActivity

    private boolean isButtonClicked = false;

    private MediaPlayer freqSound3;
    private Button playFreqButton3;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        Toolbar toolbar = (Toolbar) findViewById(R.id.toolbar);

        setSupportActionBar(toolbar);

        // FloatingActionButton fab = (FloatingActionButton) findViewById(R.id.fab);
        //fab.setOnClickListener(new View.OnClickListener() {
        //@Override
        // public void onClick(View view) {
        //      Snackbar.make(view, "Replace with your own action", Snackbar.LENGTH_LONG)
        //                .setAction("Action", null).show();
        //      }
        //});


        final MediaPlayer freqsound = MediaPlayer.create(this, R.raw.short15000);
        Button playfreqsound = (Button) this.findViewById(R.id.button1);

        playfreqsound.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                freqsound.start();
            }


        });


        final MediaPlayer freqsound2 = MediaPlayer.create(this, R.raw.short15000);
        Button playfreqsound2 = (Button) this.findViewById(R.id.button2);
        playfreqsound2.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                freqsound2.start();
            }
        });


        freqSound3 = MediaPlayer.create(this, R.raw.longfreq15000);
        playFreqButton3 = (Button) this.findViewById(R.id.button3);

        playFreqButton3.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                playButton();
            }
        });
    }

    private void playButton() {
        isButtonClicked = !isButtonClicked;

        if (isButtonClicked) {
            freqSound3.start();
        } else {
            freqSound3.stop();
            try {
                freqSound3.prepare();
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_main, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        //noinspection SimplifiableIfStatement
        if (id == R.id.action_settings) {
            return true;
        }

        return super.onOptionsItemSelected(item);
    }
}
