
byte x[200]={0};
float sample_rate=38500;
float targ_freq=15000;
int N=200;
float coeff;
float w=0;
int led =7 ;
float treshold=30;
float sine, cosine;
int i;
int n=0;
int m=0;
int ledica=0;

void setup() {
    Serial.begin(115200);
    pinMode(led, OUTPUT);
    
    //Serial.println("aa");
    

  ADCSRA = 0;             // clear ADCSRA register
  ADCSRB = 0;             // clear ADCSRB register
  ADMUX |= (0 & 0x07);    // set A0 analog input pin
  ADMUX |= (1 << REFS0);  // set reference voltage
  ADMUX |= (1 << ADLAR);  // left align ADC value to 8 bits from ADCH register

 
  ADCSRA |= (1 << ADPS2)| (1 << ADPS0);                     // 16 prescaler for 76.9 KHz
 
  ADCSRA |= (1 << ADATE); // enable auto trigger
  ADCSRA |= (1 << ADIE);  // enable interrupts when measurement complete
  ADCSRA |= (1 << ADEN);  // enable ADC
  ADCSRA |= (1 << ADSC);  // start ADC measurements

 int k= (int)(0.5+(N*targ_freq)/sample_rate);
 w=((2.0f*PI)/N)*k;
 cosine=cos(w);
 sine=sin(w);
 coeff=2*cosine;
}


ISR(ADC_vect){
//for(i=0;i<N;i++){
x[i] = ADCH;
i++;
}

//Serial.println("prekid");


void loop() {
  if(i==N){
    cli();
    i=0;
 
  float Q0;
  float Q1,Q2=0;
  int j;
 // Serial.println("loop");
  byte pom[200]={0};
  cli();
  //int y[20]={0};
for(j=0;j<N;j++){
pom[j] = x[j];
}

for(j=0;j<N;j++){
Q0=coeff*Q1-Q2+pom[j];
Q2=Q1;
Q1=Q0;
}

float real = (Q1 - Q2 * cosine);
float imag = (Q2 * sine);
float magnitude = sqrt(real*real + imag*imag);

if(magnitude>treshold){
  if(n>5){
  digitalWrite(led, HIGH);
  }
  n++;
  m=0;
}

if(magnitude<treshold){
  m++;
  if(m>10){
  if(n>5 &  n<100){
      if(ledica==0){
          digitalWrite(led,HIGH);
          ledica=1;
           }
     else {
         digitalWrite(led,LOW);
         ledica=0;
        }
        
  }
  
  if(n>100){
    //delay(500);
    digitalWrite(led,LOW);
    ledica=0; 
  }
  //Serial.println(ledica);
  n=0;
   }  
}
    delay(100);
    Serial.println(magnitude);
    sei();
}
}


